#include <iostream>

using namespace std;
typedef int Element_type;

class LinkedList {

public:
	LinkedList();
	void insertFront(Element_type);
	void insertAt(Element_type, int);
	int deleteAt(int);
	Element_type getAt(int);
	void setAt(int, int);
	int counter();
private:
	struct Node {
		Element_type data;
		Node *next;
	} *ptr;
};

// Counstructor
LinkedList::LinkedList() {
	ptr = NULL;	
}

//   x    
void LinkedList::insertFront(Element_type x) {
	ptr = (Node*)malloc(sizeof(*ptr));
	if(ptr == NULL) {
		cout<<"Error: not enough memory!"<<endl;
		return ;
	}
	ptr->next = NULL;
	ptr->data = x;
}

//   x   pos
void LinkedList::insertAt(Element_type x, int pos) {
	if(pos == 0 || counter() == 0) { //            
		insertFront(x);
		return ;
	}

	Node *new_elemnet, *local_ptr = ptr;
	new_elemnet = (Node*)malloc(sizeof(*new_elemnet));
	if(new_elemnet == NULL) {
		cout<<"Error: not enough memory!"<<endl;
		return ;
	}

	for(int i = 1; i < pos; i++) {
		local_ptr = local_ptr->next;
		if(local_ptr == NULL) { //  ,    
			cout<<"Error: no element"<<endl;
			return ;
		}
	}

	new_elemnet->next = local_ptr->next;
	new_elemnet->data = x;
	local_ptr->next = new_elemnet;
}

/*     pos
 * return 1 -   
 * return 0 -    
 */
int LinkedList::deleteAt(int pos) {
    if(counter() == 0) { //    
        cout<<"Error: list is empty"<<endl;
        return 0;
    }
    
    Node *to_delete, *local_ptr = ptr;
    if(pos == 0) { //       
        to_delete = ptr;
        ptr = ptr->next;
        free(to_delete);
        return 1;
    }
 
    for(int i = 1; i < pos; i++) {
		local_ptr = local_ptr->next;
		if(local_ptr == NULL) { //  ,        
			cout<<"Error: no element"<<endl;
			return 0;
		}
	}
    to_delete = local_ptr->next;
    local_ptr->next = to_delete->next;
    free(to_delete);
	return 1;
}

//     pos
Element_type LinkedList::getAt(int pos) {
	Node *local_ptr = ptr;
    for(int i = 1; i <= pos; i++) {
		local_ptr = local_ptr->next;
		if(local_ptr == NULL) { //  ,        
			cout<<"Error: no element"<<endl;
		}
	}
    return local_ptr->data;
}
 
//   x     pos
void LinkedList::setAt(int pos, int x) {
    Node *local_ptr = ptr;
    for(int i = 1; i < pos; i++) {
		local_ptr = local_ptr->next;
		if(local_ptr == NULL) { //  ,        
			cout<<"Error: no element"<<endl;
		}
	}
    local_ptr->data = x;
}

//      
int LinkedList::counter() {
	Node *local_ptr = ptr;
	int counter = 0;

	while(local_ptr != NULL) {
		local_ptr = local_ptr->next;
		counter++;
	}

	return counter;
}